/* Module de gestion de l'ondelettes continue */

/* Bertrand GUIHENEUF - FRACTALES 10/1996 */ 


#include "CWT1D_Filter.h"
#include "CWT1D_Wavelet.h"
#include <math.h>



void CWT1D_CreerFiltreReel(Psi, Filtre, a)
     CWT1D_t_Ondelette *Psi;
     CWT1D_t_Filtre *Filtre;
     double a;
 
{
  
  int i_min, i_max; /* indices min et max du filtre */
  double x;
  int i_filtre = 0;
  int i; 
  
  i_min = (int)floor(a * Psi->xmin); /* premier indice du filtre */
  i_max = (int)ceil(a * Psi->xmax); /* dernier indice du filtre */
  
  
  x = (double)i_min;


  for (i=i_min; i<=i_max; i++)
      {     
	Filtre->valeur[i_filtre++] = 1.0/a * (*Psi->ValeurReelle)(x/a);
	x += 1.0;
      }

  Filtre->taille_neg = -i_min;
  Filtre->taille_pos = i_max;
  Filtre->taille = i_max - i_min + 1;

}



void CWT1D_CreerFiltreComplexe(Psi, Filtre, a)
     CWT1D_t_Ondelette *Psi;
     CWT1D_t_Filtre *Filtre;
     double a;
  
{
  
  int i_min, i_max; /* indices min et max du filtre */
  double x;
  int i_filtre = 0;
  int i; 
  
  i_min = (int)floor(a * Psi->xmin); /* premier indice du filtre */
  i_max = (int)ceil(a * Psi->xmax); /* dernier indice du filtre */


  x = (double)i_min;


  for (i=i_min; i<=i_max; i++)
      {     
	Filtre->valeur[i_filtre++] = 1.0/a * (*Psi->ValeurComplexe)(x/a);
	x += 1.0;
      }

  Filtre->taille_neg = -i_min;
  Filtre->taille_pos = i_max;
  Filtre->taille = i_max - i_min + 1;

}




