/* sim_stable : stable law simulation */
/* Lotfi Belkacem 1997 */
#include "C_LAB_Interf.h"
#include <math.h>
#include <stdio.h>
#include "sim_stable.h"

#include "FRACLAB_compat.h"
void LAB_sim_stable()
{
   /* Input */
 
 Matrix *Mn;
 int    n;
 
 
 Matrix *Malpha, *Mbeta, *Mmu, *Mgamma;
 double alpha, beta, mu, gamma;
 
  /* Output */

  Matrix *MINC, *MPRO;
  double *INC,  *PRO;

  /* Work */

  double  unif;
  int i;
  long int firstvalue;

  Malpha = (Matrix *)(Interf.Param[0]);
  Mbeta = (Matrix *)(Interf.Param[1]);
  Mmu = (Matrix *)(Interf.Param[2]);
  Mgamma = (Matrix *)(Interf.Param[3]);
  Mn = (Matrix *)(Interf.Param[4]);
  

  /* get and verify the input parameters */

  if (Interf.NbParamIn != 5)
    {
      InterfError("sim_stable : you must give 5 input parameters\n");
      return;
    }
  
  alpha = MatrixGetScalar(Malpha);
  beta = MatrixGetScalar(Mbeta);
  mu = MatrixGetScalar(Mmu);
  gamma = MatrixGetScalar(Mgamma);
  n = (int)MatrixGetScalar(Mn);
  
  
  MPRO = MatrixCreate(n+1,1,"real");
  PRO = MatrixGetPr(MPRO);

  MINC = MatrixCreate(n,1,"real");
  INC = MatrixGetPr(MINC);

 
  time(&firstvalue);
  srand48(firstvalue);

	
  PRO[0]=0.0;
    
  for(i=0;i<n;i++){
    INC[i]=gamma*stable_s(alpha,beta,n)+mu;
    PRO[i+1]=PRO[i]+INC[i];
    }
  
  ReturnParam(MPRO);
  ReturnParam(MINC);
    
}
