/*-----------------------------------------------------------------------------
*                                                                              
*                                    FracLab
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* File path        : /home/users/canus/MFA.CMP/MFAH.CL/src/MFAH_hoelder.c
* File type        : C source file
* Revision         : $Revision: 1.1.1.1 $
* RCS status       : $Id: MFAH_hoelder.c,v 1.1.1.1 1999/02/10 13:39:49 guiheneu Exp $
* Created by       : (Fractales Project INRIA) Christophe Canus
* Creation date    : Sun Feb  7 16:24:19 1999
* Last edited by   : (Fractales Project INRIA) Christophe Canus
* Last edition date: Sat Aug 17 19:54:40 2002
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* Description : 
*                
*                
*                
*------------------------------------------------------------------------------
*/

#include "MFAH_hoelder.h"

/*****************************************************************************/

int MFAH_loglog(int N_n,double* mu_n,double x,short J,double* eta,double* log_eta,double* log_mu_eta_x,MFAMt_ball t_ball,MFAMt_bord t_bord)
{
  if((N_n>0)&&(mu_n!=NULL)&&(log_eta!=NULL)&&(log_mu_eta_x!=NULL))
  {
    register int j=0;
    double mu_eta_x=0;
    for(j=0;j<=J;j++)
    {
      *(log_eta+j)=log(*(eta+j));
      mu_eta_x=MFAM_mu_eta_b_x(N_n,NULL,mu_n,*(eta+j),0,1-1./N_n,x,t_ball,t_bord);
      if(mu_eta_x!=0.)
	*(log_mu_eta_x+j)=log(mu_eta_x);
      else
	*(log_mu_eta_x+j)=HUGE;
    }
    return 1;
  }
  else
  {
    fprintf(stderr,"MFAH_loglog arguments error\n");
    return 0;
  }
}

/*****************************************************************************/

int MFAH_mph(int N_n,double* mu_n,MFAMt_ball t_ball,MFAMt_bord t_bord,MFAMt_prog t_prog,double a,double A,short J,double *eta,double* log_eta,double* log_mu_eta,double* y_hat,double* origin_hat,double* alpha_hat,double* sigma2_e_hat,int M,double* x,double* alpha_x,MFAMt_lr t_lr,double* K,int* j_hat)
{
  if((N_n>0)&&(mu_n!=NULL)&&(J>0)&&(eta!=NULL)&&(M>0)&&(x!=NULL)&&(alpha_x!=NULL)&&(K!=NULL))
  {
    register int m=0;
    double E_j_min=0.,E_j_max=0.;  
    if(MFAM_scale(N_n,a,A,J+1,eta,t_prog,1)==0)
    { 
      fprintf(stderr,"MFAM_space error\n");
      return 0;
    }
    FRflg=1;
    for(m=0;m<M;m++)
    {
      if(MFAH_loglog(N_n,mu_n,*(x+m),J,eta,log_eta,log_mu_eta,t_ball,t_bord)==0)
      {
 	fprintf(stderr,"MFAH_loglog error\n");  
 	return 0; 
      }
    /*   if(MFAM_mlslr(J,log_eta,log_mu_eta,alpha_hat,origin_hat,y_hat,sigma2_e_hat)==0) */
/*       { */
/*  	fprintf(stderr,"MFAM_mlslr error\n");   */
/*  	return 0;  */
/*       } */
     /*  if(MFAM_laplslr(J,alpha_hat,sigma2_e_hat,K+m,j_hat+m,&E_j_min,&E_j_max)==0) */
/*       { */
/* 	fprintf(stderr,"MFAM_laplslr error\n"); */
/* 	return 0; */
/*       } */
      *(alpha_x+m)=(E_j_min+E_j_max)/2.; 
    }
    return 1;
  }
  else
  {
    fprintf(stderr,"MFAH_mph arguments error\n");
    return 0;
  }
}
