/*-----------------------------------------------------------------------------
*                                                                              
*                                    FracLab
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* File path        : /home/users/canus/FRACLAB-WKSP/FRACLAB/MFAL/SRC/MFAL_continuous.c
* File type        : C source file
* Revision         : $Revision: 1.2 $
* RCS status       : $Id: MFAL_continuous.c,v 1.2 1999/03/01 09:23:35 canus Exp $
* Created by       : (Fractales Project INRIA) Christophe Canus
* Creation date    : Sun Feb  7 14:51:21 1999
* Last edited by   : (Fractales Project INRIA) Christophe Canus
* Last edition date: Sun Nov 25 15:56:48 2001
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* Description : 
*                
*                
*                
*------------------------------------------------------------------------------
*/

/* Christophe Canus 1998 */

#include "MFAL_continuous.h"

/*****************************************************************************/

int MFAL_fcfl1d(int M,double* x,double* f_x,MFAMt_prog t_prog,MFAMt_osc t_osc,double p,short J,double S_min,double S_max,double* a,short Q,double* q,double* Z_a_q,MFAMt_lr t_lr,double* t_q,short* N,double* alpha,double* fl_alpha)
{
  if ((M>0)&&(f_x!=NULL)&&(p>=1.)&&(J>0)&&(S_min>=1.)&&(S_min<=S_max)&&(S_max<=M)&&(Q>0)&&(q!=NULL)&&(Z_a_q!=NULL)&&(t_q!=NULL)&&(N!=NULL)&&(alpha!=NULL)&&(fl_alpha!=NULL))
    {
      register int k=0;
      int N_tmp=0;
      double* t_q_tmp=NULL;  
      if(MFAL_fcZq1d(M,x,f_x,t_prog,t_osc,p,J,S_min,S_max,a,Q,q,Z_a_q)==0) 
	{
	  fprintf(stderr,"MFAL_fcZq1d error\n");
	  return 0;
	}
      if(MFAL_tq(J,a,Q,q,Z_a_q,t_lr,t_q)==0)
	{
	  fprintf(stderr,"MFAL_tq error\n");
	  return 0;
	}
      if((t_q_tmp=(double*)malloc((unsigned)Q*sizeof(double)))==NULL)
	{
	  fprintf(stderr,"malloc error\n");
	  return 0;
	} 
      for(k=0;k<Q;k++)
	*(t_q_tmp+k)=*(t_q+k);
      if(MFAM_bb_concave_hull(Q,q,t_q_tmp,&N_tmp)==0)
	{
	  fprintf(stderr,"MFAM_bb_concave_hull error\n");
	  free((char*)t_q_tmp);
	  return 0;
	} 
      if(MFAM_llt(N_tmp,q,t_q_tmp,alpha,fl_alpha)==0)
	{
	  fprintf(stderr,"MFAS_llt error\n");
	  return 0;
	}
      free((char*)t_q_tmp);
      *N=N_tmp;
      return 1;
    }
  else
    {
      fprintf(stderr,"MFAM_fcfl1d arguments error\n");
      return 0;
    }
}
