/*-----------------------------------------------------------------------------
*                                                                              
*                                    FracLab
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* File path        : /a/user/canus/FRACLAB-WKSP/FRACLAB/MFAL/SRC/MFAL_reyni.c
* File type        : C source file
* Revision         : $Revision: 1.2 $
* RCS status       : $Id: MFAL_reyni.c,v 1.2 1999/03/01 09:23:35 canus Exp $
* Created by       : (Fractales Project INRIA) Christophe Canus
* Creation date    : Sun Feb  7 18:47:38 1999
* Last edited by   : (Fractales Project INRIA) Christophe Canus
* Last edition date: Thu Jun 10 10:43:56 1999
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* Description : 
*                
*                
*                
*------------------------------------------------------------------------------
*/

/* Christophe Canus 1997/98 */

#include "MFAL_reyni.h"

/*****************************************************************************/

#ifndef __STDC__
int MFAL_tq(J, a, Q, q, Z_a_q, t_lr, t_q)
     short int J;
     double* a;
     int Q;
     double* q;
     double* Z_a_q;
     MFAMt_lr t_lr;
     double* t_q;
#else /* __STDC__ */
     int MFAL_tq(short J,double* a,int Q,double* q,double* Z_a_q,MFAMt_lr t_lr,double* t_q)
#endif /* __STDC__ */
{
  if((J>0)&&(a!=NULL)&&(Q>0)&&(q!=NULL)&&(Z_a_q!=NULL)&&(t_q!=NULL))
    {
      register int j=0,k=0;
      double* loga=NULL;
      double* logZ_a_q=NULL; 
      short I=20;
      double K=1.,m=0.,s=1.;
      /* input weights & variance */
      double* w=NULL;
      double* sigma2_j=NULL;
      /* output slopes & ordinates at the origin estimates*/
      double* a_hat=NULL; 
      double* b_hat=NULL;
      /* output regressed ordinate, errors & mean square error estimates */
      double* y_hat=NULL;
      double* e_hat=NULL;
      double* sigma2_e_hat=NULL;
      /* output optimal confidence constant & index, confidence intervals */
      double* K_star=NULL;
      double* j_hat=NULL;
      double* I_c_j_min=NULL; 
      double* I_c_j_max=NULL;
      /* ouput intersection interval */
      double* E_c_j_hat_min=NULL;
      double* E_c_j_hat_max=NULL;
      if((loga=(double*)malloc((unsigned)(J*sizeof(double))))==NULL)
	{
	  fprintf(stderr,"malloc error\n"); 
	  return 0;
	}
      for(j=0;j<J;j++)
	*(loga+j)=log(*(a+j)); 
      if((logZ_a_q=(double*)malloc((unsigned)(J*sizeof(double))))==NULL)
	{
	  fprintf(stderr,"malloc error\n"); 
	  return 0;
	} 
      if((t_lr==MFAM_MLSLR)||(t_lr==MFAM_MLLR)||(t_lr==MFAM_LAPLSLR))
	{
	  if((a_hat=(double*)malloc((unsigned)(J*sizeof(double))))==NULL) 
	    {
	      fprintf(stderr,"malloc error\n"); 
	      return 0;
	    }
	  if((b_hat=(double*)malloc((unsigned)(J*sizeof(double))))==NULL)
	    {
	      fprintf(stderr,"malloc error\n"); 
	      return 0;
	    }
	  if((y_hat=(double*)malloc((unsigned)((J+2)*(J-1)/2*sizeof(double))))==NULL)
	    {
	      fprintf(stderr,"malloc error\n"); 
	      return 0;
	    }
	  if((e_hat=(double*)malloc((unsigned)((J+2)*(J-1)/2*sizeof(double))))==NULL)
	    {
	      fprintf(stderr,"malloc error\n"); 
	      return 0;
	    }  
	  if((sigma2_e_hat=(double*)malloc((unsigned)(J*sizeof(double))))==NULL)
	    {
	      fprintf(stderr,"malloc error\n"); 
	      return 0;
	    }
	}
      else
	{
	  if(t_lr!=MFAM_PLSLR)
	    I=1;
	  if((a_hat=(double*)malloc((unsigned)(I*sizeof(double))))==NULL) 
	    {
	      fprintf(stderr,"malloc error\n"); 
	      return 0;
	    }
	  if((b_hat=(double*)malloc((unsigned)(I*sizeof(double))))==NULL)
	    {
	      fprintf(stderr,"malloc error\n"); 
	      return 0;
	    }
	  if((y_hat=(double*)malloc((unsigned)(I*J*sizeof(double))))==NULL)
	    {
	      fprintf(stderr,"malloc error\n"); 
	      return 0;
	    }
	  if((e_hat=(double*)malloc((unsigned)(J*sizeof(double))))==NULL)
	    {
	      fprintf(stderr,"malloc error\n"); 
	      return 0;
	    } 
	  if((sigma2_e_hat=(double*)malloc((unsigned)(J*sizeof(double))))==NULL)
	    {
	      fprintf(stderr,"malloc error\n"); 
	      return 0;
	    }
	}
      if((t_lr==MFAM_WLSLR)||(t_lr==MFAM_PLSLR)||(t_lr==MFAM_MLLR))
	{
	  if((w=(double*)malloc((unsigned)(J*sizeof(double))))==NULL)
	    {
	      fprintf(stderr,"malloc error\n"); 
	      return 0;
	    }
	  if(MFAM_zeros(J,w)==0)
	    {
	      fprintf(stderr,"MFAM_zeros error\n"); 
	      return 0;
	    }  
	}
      if((t_lr==MFAM_MLLR)||(t_lr==MFAM_LAPLSLR))
	{
	  if((sigma2_j=(double*)malloc((unsigned)(J*sizeof(double))))==NULL)
	    {
	      fprintf(stderr,"malloc error\n"); 
	      return 0;
	    }
	  if(MFAM_zeros(J,sigma2_j)==0)
	    {
	      fprintf(stderr,"MFAM_zeros error\n"); 
	      return 0;
	    }  
	}
      if(t_lr==MFAM_LAPLSLR)
	{  
	  if((K_star=(double*)malloc((unsigned)sizeof(double)))==NULL)
	    {
	      fprintf(stderr,"malloc error\n"); 
	      return 0;
	    }
	  if((j_hat=(double*)malloc((unsigned)sizeof(double)))==NULL)
	    {
	      fprintf(stderr,"malloc error\n"); 
	      return 0;
	    }
	  if((I_c_j_min=(double*)malloc((unsigned)(J*sizeof(double))))==NULL)
	    {
	      fprintf(stderr,"malloc error\n"); 
	      return 0;
	    }
	  if((I_c_j_max=(double*)malloc((unsigned)(J*sizeof(double))))==NULL)
	    {
	      fprintf(stderr,"malloc error\n"); 
	      return 0;
	    }  
	  if((E_c_j_hat_min=(double*)malloc((unsigned)sizeof(double)))==NULL)
	    {
	      fprintf(stderr,"malloc error\n"); 
	      return 0;
	    }
	  if((E_c_j_hat_max=(double*)malloc((unsigned)sizeof(double)))==NULL)
	    {
	      fprintf(stderr,"malloc error\n"); 
	      return 0;
	    }
	  if(MFAM_zeros(J,I_c_j_min)==0)
	    {
	      fprintf(stderr,"MFAM_zeros error\n"); 
	      return 0;
	    }
	  if(MFAM_zeros(J,I_c_j_max)==0)
	    {
	      fprintf(stderr,"MFAM_zeros error\n"); 
	      return 0;
	    } 
	}
      for(k=0;k<Q;k++)
	{
	  for(j=0;j<J;j++)
	    *(logZ_a_q+j)=log(*(Z_a_q+Q*j+k));
	  if(MFAM_lr(J,loga,logZ_a_q,t_lr,K,sigma2_j,w,I,m,s,t_q+k,b_hat,y_hat,e_hat,sigma2_e_hat,K_star,j_hat,I_c_j_min,I_c_j_max,E_c_j_hat_min,E_c_j_hat_max)==0)
	    {
	      fprintf(stderr,"MFAM_lr error\n");
	      return 0;
	    }
	}
      free((char*)logZ_a_q);
      free((char*)loga);
      if((t_lr==MFAM_MLSLR)||(t_lr==MFAM_MLLR)||(t_lr==MFAM_LAPLSLR))
	{
	  free((char*)a_hat);
	  free((char*)b_hat);
	  free((char*)y_hat);
	  free((char*)e_hat);
	  free((char*)sigma2_e_hat);
	} 
      else
	{
	  free((char*)a_hat);
	  free((char*)b_hat);
	  free((char*)y_hat);
	  free((char*)e_hat);
	  free((char*)sigma2_e_hat);
	}
      if((t_lr==MFAM_WLSLR)||(t_lr==MFAM_PLSLR)||(t_lr==MFAM_MLLR))
	free((char*)w);
      if(t_lr==MFAM_LAPLSLR)
	{ 
	  free((char*)K_star);
	  free((char*)j_hat);
	  free((char*)I_c_j_min);
	  free((char*)I_c_j_max);
	  free((char*)E_c_j_hat_min);
	  free((char*)E_c_j_hat_max);
	}
	return 1;
    }
  else
    {
      fprintf(stderr,"MFAL_tq arguments error\n");
      return 0;
    }
}
