/*-----------------------------------------------------------------------------
*                                                                              
*                                    FracLab
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* File path        : /home/users/canus/MFA.CMP/MFAM.CL/src/MFAM_capacity.c
* File type        : C source file
* Created by       : (Fractales Project INRIA) Christophe Canus
* Creation date    : Tue Aug 13 21:17:47 2002
* Last edited by   : (Fractales Project INRIA) Christophe Canus
* Last edition date: Tue Aug 20 21:30:21 2002
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* Description : 
*                
*                
*                
*------------------------------------------------------------------------------
*/

#include "MFAM_capacity.h"

/*****************************************************************************/

int MFAM_capastr(char* capastr,MFAMt_capa* t_capa)
{
  if(strcmp(MFAM_SUMSTR,capastr)==0)
    *t_capa=MFAM_SUM;
  else if(strcmp(MFAM_LPSUMSTR,capastr)==0)
    *t_capa=MFAM_LPSUM; 
  else if(strcmp(MFAM_L2SUMSTR,capastr)==0)
    {
      *t_capa=MFAM_LPSUM;
      p=2;
    }
  else if(strcmp(MFAM_MINSTR,capastr)==0)
    *t_capa=MFAM_MIN;
  else if(strcmp(MFAM_MAXSTR,capastr)==0)
    *t_capa=MFAM_MAX; 
  else if(strcmp(MFAM_ISOSTR,capastr)==0)
    *t_capa=MFAM_ISO; 
  else if(strcmp(MFAM_ADAPISOSTR,capastr)==0)
    *t_capa=MFAM_ADAPISO;
  else 
    return 0;
  return 1;
}

/*****************************************************************************/

double MFAM_sum(double sum_meas,double meas)
{
  return sum_meas+=meas/norm_meas;
}

/*****************************************************************************/

double MFAM_lpsum(double sum_meas,double meas)
{
  return sum_meas+=pow(meas/norm_meas,p);
}

/*****************************************************************************/

double MFAM_min(double min_c,double c)
{
  return MIN(min_c,c);
}

/*****************************************************************************/

double MFAM_max(double max_c,double c)
{
  return MAX(max_c,c);
} 

/*****************************************************************************/

double MFAM_iso(double iso_c,double c)
{  
  return iso_c+=ISO(c,c_ref,q);
}

/*****************************************************************************/

double MFAM_adapiso(double adapiso_c,double c)
{  
  return adapiso_c+=ADAPISO(c,c_ref,sigma2);
}
