/*-----------------------------------------------------------------------------
*                                                                              
*                                    FracLab
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* File path        : /home/users/canus/MFA.CMP/MFAM.CL/inc/MFAM_capacity.h
* File type        : C header file
* Created by       : (Fractales Project INRIA) Christophe Canus
* Creation date    : Tue Aug 13 21:17:42 2002
* Last edited by   : (Fractales Project INRIA) Christophe Canus
* Last edition date: Tue Aug 20 21:32:15 2002
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* Description : 
*                
*                
*                
*------------------------------------------------------------------------------
*/

#ifndef _MFAM_capacity_h_
#define _MFAM_capacity_h_
#include "MFAM_include.h"

double norm_meas;
double p;
double c_ref;
double q;
double sigma2;

#undef SUM
#define SUM(x,y) (double)(x)+=(double)(y)

#undef LPSUM
#define LPSUM(x,y,p) (double)(x)+=(double)(pow((double)y,p))

#undef ISO
#define ISO(x,y,q) (fabs(x-y)<q?1.0:0.0)

#undef ADAPISO
#define ADAPISO(x,y,sigma2) exp(-((x-y)*(x-y))/sigma2);

typedef enum
{
  MFAM_SUM=0,
  MFAM_LPSUM=1,
  MFAM_MIN=2,
  MFAM_MAX=3,
  MFAM_ISO=4,
  MFAM_ADAPISO=5
} MFAMt_capa;

#define MFAM_SUMSTR "sum"
#define MFAM_L2SUMSTR "l2sum"
#define MFAM_LPSUMSTR "lpsum"
#define MFAM_MINSTR "min"
#define MFAM_MAXSTR "max"
#define MFAM_ISOSTR "iso"
#define MFAM_ADAPISOSTR "adapiso"


#ifndef __STDC__
extern int MFAM_capastr();
extern double MFAM_sum();
extern double MFAM_lpsum();
extern double MFAM_min();
extern double MFAM_max();
extern double MFAM_iso();
extern double MFAM_adapiso();
#else /* __STDC__ */
extern int MFAM_capastr(char*,MFAMt_capa*);
extern double MFAM_sum(double,double);
extern double MFAM_lpsum(double,double);
extern double MFAM_min(double,double);
extern double MFAM_max(double,double);
extern double MFAM_iso(double,double);
extern double MFAM_adapiso(double,double);
#endif /* __STDC__ */

#endif /* _MFAM_capacity_h_ */
