/*-----------------------------------------------------------------------------
*                                                                              
*                                    FracLab
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* File path        : /home/canus/MFA.CMP/MFAM.CL/src/MFAM_concave_hull.c
* File type        : C source file
* Revision         : $Revision: 1.1.1.1 $
* RCS status       : $Id: MFAM_concave_hull.c,v 1.1.1.1 1999/02/10 13:29:04 guiheneu Exp $
* Created by       : (Fractales Project INRIA) Christophe Canus
* Creation date    : Sun Feb  7 15:56:43 1999
* Last edited by   : (Fractales Project INRIA) Christophe Canus
* Last edition date: Sun Feb  7 15:56:44 1999
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* Description : 
*                
*                
*                
*------------------------------------------------------------------------------
*/

/* Christophe Canus 1997-98 */

#include "MFAM_concave_hull.h"

/*****************************************************************************/

int MFAM_slope(int n,double* x,double* u_x,double* s_x)
{
  int i,k=0;
  for(i=0;i<n-1;i++)
  {    
    *(s_x+k)=(*(u_x+i+1)-*(u_x+i))/(*(x+i+1)-*(x+i));
    k++;
  }
  return(k+1);
}

/*****************************************************************************/

int MFAM_bb(double* s_x,int n,double* x,double* u_x,int* bool)
{
  int i=0,j=0,k=n-2;
  while((*bool)&&(i<k))
  {
    if(*(s_x+i+1)>*(s_x+i)) 
    {
      for(j=i+1;j<=k;j++)
      {
	*(x+j)=*(x+j+1);
	*(u_x+j)=*(u_x+j+1);
      }
      *bool=0;
      k--;
    }
    else i++;    
  }
  return(k+2);  
}

/*****************************************************************************/

int MFAM_bb_concave_hull(int n,double* x,double* u_x,int* rn)
{
  int eliminated_pt=0;
  double *s_x=NULL;
  if((s_x=(double*)malloc((unsigned)(n*sizeof(double))))==NULL)
  {
    fprintf(stderr,"malloc error\n");
    return 0; 
  }
  *rn=n;
  while(!eliminated_pt)
  {
    eliminated_pt=1;
    *rn=MFAM_slope(*rn,x,u_x,s_x);
    *rn=MFAM_bb(s_x,*rn,x,u_x,&eliminated_pt);
  }
  free((char*)s_x);
  return 1;    
}
