/*-----------------------------------------------------------------------------
*                                                                              
*                                    FracLab
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* File path        : /home/users/canus/FRACLAB-WKSP/FRACLAB/MFAM/SRC/MFAM_include.h
* File type        : C header file
* Revision         : $Revision: 1.2 $
* RCS status       : $Id: MFAM_include.h,v 1.2 1999/02/15 09:23:13 guiheneu Exp $
* Created by       : (Fractales Project INRIA) Christophe Canus
* Creation date    : Sun Feb  7 16:06:36 1999
* Last edited by   : (Fractales Project INRIA) Christophe Canus
* Last edition date: Mon Nov 18 21:48:51 2002
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* Description : 
*                
*                
*                
*------------------------------------------------------------------------------
*/

/* Christophe Canus 1996-97-98 */

#ifndef _MFAM_include_h_
#define _MFAM_include_h_

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <float.h>

#undef MIN
#define MIN(x,y) ((double)(x)>(double)(y)?(y):(x))

#undef MAX
#define MAX(x,y) ((double)(x)>(double)(y)?(x):(y))

#define ROUND(x)                                                \
((((x) - floor((double)(x))) < 0.5)                             \
? floor((double) (x)) : (ceil((double) (x))))

#undef TIMERSUB
#define TIMERSUB(a, b, result)					\
   do {								\
      (result)->tv_sec = (a)->tv_sec - (b)->tv_sec;		\
      (result)->tv_usec = (a)->tv_usec - (b)->tv_usec;		\
      if ((result)->tv_usec < 0) {				\
	 --(result)->tv_sec;					\
	 (result)->tv_usec += 1000000;				\
      }								\
   } while (0)

#ifndef NOFRACLAB
#include "FRACLAB_compat.h"

#if defined(__CYGWIN32__) 
#include <sys\utime.h>
#else /* __CYGWIN32__ */

#if defined(_MSC_VER) 
#include <sys\utime.h>
#else /* _MSC_VER */
#include <sys/time.h>
#endif /* _MSC_VER */

#endif /* __CYGWIN32__ */

#else /* def NOFRACLAB */

#if defined(__STDC__) 
#else /* __STDC__ */
extern int fclose();
extern int fprintf();
extern int snprintf();
extern int printf();
extern int fscanf();
extern char* strdup();
#endif /* __STDC__ */

#ifndef RAND_MAX
#define RAND_MAX pow(2.,31.)-1
#endif /* RAND_MAX */

#ifndef M_PI
#define M_PI 3.14159265358979323846
#endif /* M_PI */

#ifndef HUGE
#define HUGE 1e6
#endif /* HUGE */

#ifdef MAXFLOAT
#undef HUGE
#define HUGE MAXFLOAT
#endif /* MAXFLOAT */

#endif /* NOFRACLAB */

#endif /*_MFAM_include_h_*/
