/*-----------------------------------------------------------------------------
*                                                                              
*                                    FracLab
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* File path        : /home/canus/MFA.CMP/MFAM.CL/inc/MFAM_kernel.h
* File type        : C header file
* Revision         : $Revision: 1.1.1.1 $
* RCS status       : $Id: MFAM_kernel.h,v 1.1.1.1 1999/02/10 13:29:04 guiheneu Exp $
* Created by       : (Fractales Project INRIA) Christophe Canus
* Creation date    : Sun Feb  7 16:06:30 1999
* Last edited by   : (Fractales Project INRIA) Christophe Canus
* Last edition date: Sun Feb  7 16:06:31 1999
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* Description : 
*                
*                
*                
*------------------------------------------------------------------------------
*/

/* Christophe Canus 1997-98 */

#ifndef _MFAM_kernel_h_
#define _MFAM_kernel_h_

#include "MFAM_include.h"
#include "MFAM_misc.h"

#ifndef TWOPI
#define TWOPI 6.2831853 /* 2.*PI */
#endif /* TWOPI */

#ifndef SQRTTWOPI
#define SQRTTWOPI 2.5066283 /* sqrt(TWOPI) */
#endif /* SQRTTWOPI */

#ifndef MOLLIFIER
#define MOLLIFIER 0.4439938162
#endif /* MOLLIFIERT */

#ifndef SQRTFIVE
#define SQRTFIVE 2.236068 /* sqrt(5.) */
#endif /* SQRTFIVE */

#ifndef EPANECHNIKOV
#define EPANECHNIKOV 1.677051 /* 3./4.*sqrt(5.) */
#endif /* EPANECHNIKOV */

#ifndef QUARTIC 
#define QUARTIC .9375 /* 15/16 */
#endif /* QUARTIC */

#ifndef GAUSSIANH 
#define GAUSSIANH 1.06
#endif /* GAUSSIANH */
 
#ifndef EPANECHNIKOVH 
#define EPANECHNIKOVH 2.34
#endif /* EPANECHNIKOVH */

#ifndef QUARTICH 
#define QUARTICH 2.78
#endif /* QUARTICH */

typedef enum
{
  MFAM_INTEGRATED=0,
  MFAM_BOXCAR=1,
  MFAM_TRIANGLE=2,
  MFAM_GAUSSIAN=3,
  MFAM_MOLLIFIER=4,
  MFAM_EPANECHNIKOV=5,
  MFAM_QUARTIC=6
} MFAMt_kern;

#define MFAM_INTEGRATEDSTR "integrated"
#define MFAM_BOXCARSTR "box"
#define MFAM_TRIANGLESTR "tri"
#define MFAM_GAUSSIANSTR "gau"
#define MFAM_MOLLIFIERSTR "mol"
#define MFAM_EPANECHNIKOVSTR "epa"
#define MFAM_QUARTICSTR "qua"

#ifndef __STDC__
extern double MFAM_boxcar();
extern double MFAM_triangle();
extern double MFAM_gauss();
extern double MFAM_mol();
extern double MFAM_epa();
extern double MFAM_quartic();
#else /* __STDC__ */
extern double MFAM_boxcar(double);
extern double MFAM_triangle(double);
extern double MFAM_gauss(double);
extern double MFAM_mol(double);
extern double MFAM_epa(double);
extern double MFAM_quartic(double);
#endif /* __STDC__ */

#ifndef __STDC__
extern int MFAM_kernelstr();
#else /* __STDC__ */
extern int MFAM_kernelstr(char*,MFAMt_kern*);
#endif /* __STDC__ */

#ifndef __STDC__
extern int MFAM_kernelconvolve();
#else /* __STDC__ */
extern int MFAM_kernelconvolve(int,double*,double,double(*)(double),int,int,double*,double*);
#endif /* __STDC__ */

#endif /*_MFAM_kernel_h_*/ 
