/*-----------------------------------------------------------------------------
*                                                                              
*                                    FracLab
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* File path        : /home/canus/MFA.CMP/MFAM.CL/src/MFAM_law.c
* File type        : C source file
* Revision         : $Revision: 1.1.1.1 $
* RCS status       : $Id: MFAM_law.c,v 1.1.1.1 1999/02/10 13:29:04 guiheneu Exp $
* Created by       : (Fractales Project INRIA) Christophe Canus
* Creation date    : Sun Feb  7 15:56:18 1999
* Last edited by   : (Fractales Project INRIA) Christophe Canus
* Last edition date: Sun Feb  7 15:56:19 1999
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* Description : 
*                
*                
*                
*------------------------------------------------------------------------------
*/

/* Christophe Canus 1997-98 */

#include "MFAM_law.h"

/*****************************************************************************/

int MFAM_normal_law(double m,double sigma,int n,double* n_sample)
{
  if((m>=0.)&&(sigma>0.)&&(n>0.)&&(n_sample!=NULL))
  {  
    register int k=0;
    random_seed();
    /* normal r.v.'s with mean m and standard deviation sigma */
    for(k=0;k<n;k++)
      *(n_sample+k)=MFAM_normal(m,sigma*sigma);
    return 1;
  }
  else
  {
    fprintf(stderr,"MFAM_normal_law arguments error\n");
    return 0;
  }
}

/*****************************************************************************/

int MFAM_Rayleigh_law(double c,int n,double* n_sample)
{
  if((c>0.)&&(n>0)&&(n_sample!=NULL))
  {  
    register int k=0;
    random_seed();
    /* Rayleigh r.v.'s with coefficient c */
    for(k=0;k<n;k++)
      *(n_sample+k)=MFAM_Rayleigh(c);  
    return 1;
  }
  else
  {
    fprintf(stderr,"MFAM_Rayleigh_law arguments error\n");
    return 0;
  }
}
 
/*****************************************************************************/

int MFAM_uniform_law(double a,double b,int n,double* n_sample)
{
  if((a>=0.)&&(b>a)&&(n>0)&&(n_sample!=NULL))
  {  
    register int k=0;
    random_seed();
    /* uniform r.v.'s in [a,b] */
    for(k=0;k<n;k++)
      *(n_sample+k)=MFAM_uniform(a,b);  
    return 1;
  }
  else
  {
    fprintf(stderr,"MFAM_uniform_law arguments error\n");
    return 0;
  }
}

/*****************************************************************************/

int MFAM_lognormal_law(double m, double sigma,int n,double* n_sample)
{
  if((m>=0.)&&(sigma>0.)&&(n>0)&&(n_sample!=NULL))
  {  
    register int k=0;
    random_seed();
    /* lognormal r.v.'s with mean m and standard deviation sigma */
    for(k=0;k<n;k++)
      *(n_sample+k)=MFAM_lognormal(m,sigma*sigma);  
    return 1;
  }
  else
  {
    fprintf(stderr,"MFAM_lognormal_law arguments error\n");
    return 0;
  }
} 

