/*-----------------------------------------------------------------------------
*                                                                              
*                                    FracLab
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* File path        : /home/canus/MFA.CMP/MFAM.CL/src/MFAM_legendre.c
* File type        : C source file
* Revision         : $Revision: 1.1.1.1 $
* RCS status       : $Id: MFAM_legendre.c,v 1.1.1.1 1999/02/10 13:29:04 guiheneu Exp $
* Created by       : (Fractales Project INRIA) Christophe Canus
* Creation date    : Sun Feb  7 15:55:09 1999
* Last edited by   : (Fractales Project INRIA) Christophe Canus
* Last edition date: Sun Feb  7 15:55:10 1999
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* Description : 
*                
*                
*                
*------------------------------------------------------------------------------
*/

/* Christophe Canus 1997-98 */

#include "MFAM_legendre.h"

/*****************************************************************************/

int MFAM_llt(int n,double* x,double* u_x,double* s,double* u_star_s)
{
  if((n>0)&&(x!=NULL)&&(u_x!=NULL)&&(s!=NULL)&&(u_star_s!=NULL))
    {
      register int i=0;
      *s=(*(u_x+n-1)-*(u_x+n-2))/(*(x+n-1)-*(x+n-2));
      *u_star_s=*s**(x+n-1)-*(u_x+n-1); 
      for (i=1;i<n-1;i++)
	{
	  *(s+i)=(*(u_x+n-i)-*(u_x+n-2-i))/(*(x+n-i)-*(x+n-2-i));
	  *(u_star_s+i)=s[i]*x[n-1-i]-u_x[n-1-i];
	}
      *(s+n-1)=(u_x[1]-u_x[0])/(x[1]-x[0]);
      *(u_star_s+n-1)=*(s+n-1)**x-*u_x;
      return 1;
    }
  else
    {
      fprintf(stderr,"MFAM_llt arguments error\n");
      return 0;
    }
}
