/*-----------------------------------------------------------------------------
*                                                                              
*                                    FracLab
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* File path        : /home/canus/MFA.CMP/MFAM.CL/src/MFAM_lepskii.c
* File type        : C source file
* Revision         : $Revision: 1.1.1.1 $
* RCS status       : $Id: MFAM_lepskii.c,v 1.1.1.1 1999/02/10 13:29:04 guiheneu Exp $
* Created by       : (Fractales Project INRIA) Christophe Canus
* Creation date    : Sun Feb  7 15:54:59 1999
* Last edited by   : (Fractales Project INRIA) Christophe Canus
* Last edition date: Sun Feb  7 15:55:00 1999
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* Description : 
*                
*                
*                
*------------------------------------------------------------------------------
*/

/* Christophe Canus 1997-98 */

#include "MFAM_lepskii.h"

/*****************************************************************************/

int MFAM_lap(int J,double* theta_hat_j,double* sigma2_j,double K,double* K_star,double* j_hat,double* I_c_j_min,double* I_c_j_max,double* E_c_j_hat_min,double* E_c_j_hat_max)
{      
  if((J>1)&&(theta_hat_j!=NULL)&&(sigma2_j!=NULL)&&(K>=1.)&&(K_star!=NULL)&&(j_hat!=NULL)&&(I_c_j_min!=NULL)&&(I_c_j_max!=NULL)&&(E_c_j_hat_min!=NULL)&&(E_c_j_hat_max!=NULL))
  { 
    register int j=0;
    int boolean=1;
    double min=0.,max=0.;
    if(MFAM_iszeros(J,sigma2_j)==1)
    {
      *sigma2_j=1;
      for(j=1;j<J;j++)
	*(sigma2_j+j)=1./(j+1);
    }   
    *K_star=1+pow(-2*log(*(sigma2_j+J-1)/(J**sigma2_j)),.5);  
    if(K==0.)
      K=*K_star;
    j=0;
    *E_c_j_hat_min=*(theta_hat_j+j)-K*pow(*(sigma2_j+j),.5);
    *E_c_j_hat_max=*(theta_hat_j+j)+K*pow(*(sigma2_j+j),.5);
    while(boolean)
    {
      *(I_c_j_min+j)=*(theta_hat_j+j)-K*pow(*(sigma2_j+j),.5);
      *(I_c_j_max+j)=*(theta_hat_j+j)+K*pow(*(sigma2_j+j),.5);
      min=(*E_c_j_hat_min>*(I_c_j_min+j)?*E_c_j_hat_min:*(I_c_j_min+j));
      max=(*E_c_j_hat_max<*(I_c_j_max+j)?*E_c_j_hat_max:*(I_c_j_max+j));
      if(min>max)
      {
	*j_hat=j-1;
	*(I_c_j_min+j)=0.;
	*(I_c_j_max+j)=0.;
	boolean=0;
      }
      else
      {
	*E_c_j_hat_min=min;
	*E_c_j_hat_max=max;
	j++;
	boolean=(j<J);
      }  
    }
    if(j==J)
      *j_hat=J-1;
#ifdef MFAMDEBUG
    fprintf(stderr,"j_hat=%f\n",*j_hat);
#endif /* MFAMDEBUG */
    return 1;
  }
  else
  {
    fprintf(stderr,"MFAM_lap arguments error\n");
    return 0;
  }
}

