/*-----------------------------------------------------------------------------
*                                                                              
*                                    FracLab
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* File path        : /home/canus/MFA.CMP/MFAS.CL/src/MFAS_cnk.c
* File type        : C source file
* Revision         : $Revision: 1.1.1.1 $
* RCS status       : $Id: MFAS_cnk.c,v 1.1.1.1 1999/02/10 13:43:28 guiheneu Exp $
* Created by       : (Fractales Project INRIA) Christophe Canus
* Creation date    : Sun Feb  7 16:15:05 1999
* Last edited by   : (Fractales Project INRIA) Christophe Canus
* Last edition date: Sun Feb  7 16:15:06 1999
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* Description : 
*                
*                
*                
*------------------------------------------------------------------------------
*/

#include "MFAS_cnk.h"

/******************/
double MFAS_iterative_factorial(short n) 
{
   register int i=0;
   double factorial=1.;
   for(i=2;i<=n;i++) 
      factorial*=(double)i;
   return factorial;
}

/******************/
double MFAS_iterative_combinatorial(short n, short p) 
{
   register int i;
   double factorial,combinatorial=1.;
   if (p>n-p) 
      p=n-p;
   factorial=MFAS_iterative_factorial(p);
   for(i=n;i>=n-p+1;i--) 
      combinatorial*=(double)i;
   return combinatorial/factorial;
}

int MFAS_phi_n_0_k(unsigned int k) 
{
  register int n=0,p=0;
  while (k!=0) 
  {
    if (k&0x1) 
    {
      n++;
      fprintf(stderr,"1");
    } 
    else 
      fprintf(stderr,"0");
    k=k>>1;
    p++;
  }

  fprintf(stderr," ");
  return n;
}

/******************/
double *hoelder_binomial(short n,double p0)
{
   if((n>0)&&(0.<=p0)&&(p0<=1.))
   {
      register int k=0;
      double *beta_n=NULL;
      beta_n=(double*)malloc((unsigned)((n+1)*sizeof(double)));
      if(p0>=.5)
	 p0=1.-p0;
      for(k=0;k<n+1;k++)
	 *(beta_n+k)=-((double)k/(double)n)*log(p0)/log(2.)
	    -((double)(n-k)/(double)n)*log(1-p0)/log(2.);
      return beta_n;
   }
   else
   {
      fprintf(stdout,"hoelder_binomial error\n"); 
      return NULL;
   }
   
}  


