/*-----------------------------------------------------------------------------
*                                                                              
*                                    FracLab
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* File path        : /home/canus/MFA.CMP/MFAS.CL/src/MFAS_lognormal.c
* File type        : C source file
* Revision         : $Revision: 1.1.1.1 $
* RCS status       : $Id: MFAS_lognormal.c,v 1.1.1.1 1999/02/10 13:43:28 guiheneu Exp $
* Created by       : (Fractales Project INRIA) Christophe Canus
* Creation date    : Sun Feb  7 16:14:32 1999
* Last edited by   : (Fractales Project INRIA) Christophe Canus
* Last edition date: Sun Feb  7 16:14:33 1999
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* Description : 
*                
*                
*                
*------------------------------------------------------------------------------
*/

#include "MFAS_lognormal.h"

static void lnm1d(short,int,int,double,double,double,double*);
static void lnm2d(short,short,int,int,int,int,double,double,double,int,double*);

/*****************************************************************************/

int MFAS_lnm1d(short n,short B,double m,double sigma_2,double* mu_n)
{
  if((n>0)&&(B>0)&&(sigma_2>0.)&&(mu_n!=NULL))
  {
    int B_pow_n=(int)pow((double)B,(double)n);  
    random_seed();
    lnm1d(B,0,B_pow_n,1.,m,sigma_2,mu_n);
    return 1;
  }
  else
  {
    fprintf(stderr,"MFAS_lnm1d arguments error\n");
    return 0;
  }
}

/*****************************************************************************/

static void lnm1d(short B,int k,int nu_n,double mu,double m,double sigma_2,double* mu_n)
{
  if(nu_n>=B)
  {
    short i=0;
    for(i=0;i<B;i++)
      lnm1d(B,k+i*nu_n/B,nu_n/B,mu*MFAM_lognormal(m,sigma_2),m,sigma_2,mu_n);
  }
  else
    *(mu_n+k)=mu;
}

/*****************************************************************************/

int MFAS_lnm2d(short n,short Bx,short By,double m,double sigma_2,double* mu_n)
{
  if((n>0)&&(Bx>0)&&(By>0)&&(m!=0.)&&(mu_n!=NULL))
  {
    int Bx_pow_n=(int)pow((double)Bx,(double)n);
    int By_pow_n=(int)pow((double)By,(double)n);
    random_seed();
    lnm2d(Bx,By,0,0,Bx_pow_n,By_pow_n,m,sigma_2,1.,By_pow_n,mu_n);
    return 1;
  }
  else
  {
    fprintf(stderr,"MFAS_lnm2d error\n");
    return 0;
  }
}

/*****************************************************************************/

static void lnm2d(short Bx,short By,int i,int j,int nux_n,int nuy_n,double mu,double m,double sigma_2,int By_pow_n,double* mu_n)
{ 
  if((nux_n>=Bx)&&(nuy_n>=By))
  {
    short bx=0,by=0;
    for(bx=0;bx<Bx;bx++)
      for(by=0;by<By;by++)
	lnm2d(Bx,By,i+bx*nux_n/Bx,j+by*nuy_n/By,nux_n/Bx,nuy_n/By,mu*MFAM_lognormal(m,sigma_2),m,sigma_2,By_pow_n,mu_n);
  }
  else
    *(mu_n+i*By_pow_n+j)=mu;
} 
