/*-----------------------------------------------------------------------------
*                                                                              
*                                    FracLab
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* File path        : /home/canus/MFA.CMP/MFAS.CL/src/MFAS_misc.c
* File type        : C source file
* Revision         : $Revision: 1.1.1.1 $
* RCS status       : $Id: MFAS_misc.c,v 1.1.1.1 1999/02/10 13:43:28 guiheneu Exp $
* Created by       : (Fractales Project INRIA) Christophe Canus
* Creation date    : Sun Feb  7 16:14:16 1999
* Last edited by   : (Fractales Project INRIA) Christophe Canus
* Last edition date: Sun Feb  7 16:14:17 1999
*                                                                              
*------------------------------------------------------------------------------
*                                                                              
* Description : 
*                
*                
*                
*------------------------------------------------------------------------------
*/

#include "MFAS_misc.h"

/***************/
int MFAS_intm(int nu_n,double *mu_n,int x_nb,double *f_x)
{
  if((nu_n>0)&&(mu_n!=NULL)&&(x_nb>0)&&(f_x!=NULL)&&(x_nb=nu_n+1))
  {
    register int k=0;
    *f_x=0.;
    for(k=1;k<x_nb;k++)
      *(f_x+k)=*(f_x+k-1)+*(mu_n+k-1);
    return 1;
  } 
  else
  {
    fprintf(stderr,"MFAS_intm arguments error\n");
    return 0;
  }
}

/***************/
int MFAS_sum2m(int nu1_n,double *mu1_n,int nu2_n,double *mu2_n,int nu_n,double *mu_n)
{
  if((nu1_n>0)&&(mu1_n!=NULL)&&(nu2_n>0)&&(mu2_n!=NULL)&&(nu_n>0)&&(mu_n!=NULL)&&(nu_n==(nu1_n<nu2_n?nu1_n:nu2_n)))
  {
    register int k=0;
    for(k=0;k<nu_n;k++)
      *(mu_n+k)=.5**(mu1_n+k);
    for(k=0;k<nu_n;k++)
      *(mu_n+k)+=.5**(mu2_n+k);
    return 1;
  }
  else
  {
    fprintf(stderr,"MFAS_sum2m arguments error\n");
    return 0;
  }
}
/***************/
int MFAS_lump2m(int nu1_n,double *mu1_n,int nu2_n,double *mu2_n,int nu_n,double *mu_n)
{
  if((nu1_n>0)&&(mu1_n!=NULL)&&(nu2_n>0)&&(mu2_n!=NULL)&&(nu_n>0)&&(mu_n!=NULL)&&(nu_n==nu1_n+nu2_n))
  {   
    register int k=0;
    for(k=0;k<nu1_n;k++)
      *(mu_n+k)=.5**(mu1_n+k); 
    for(k=0;k<nu2_n;k++)
      *(mu_n+nu1_n+k)=.5**(mu2_n+k); 
    return 1;
  }
  else
  {
    fprintf(stderr,"MFAS_lump2m arguments error\n");
    return 0;
  }
}
/***************/
typedef struct  
{ 
  double x; 
  double y; 
} point; 

/******************/ 
int p_compare(point *p1,point *p2)  
{ 
  if (p1->x>p2->x)  
    return 1; 
  else  
    if (p1->x<p2->x)  
      return -1; 
  else /* p1->x==p2->x) */
    return 0; 
 } 

/******************/
int MFAS_sum2s(int N1,double *alpha1,double *f_alpha1,int N2,double *alpha2,double *f_alpha2,double *alpha,double *f_alpha,int *N) 
{ 
  if((N1>0)&&(alpha1!=NULL)&&(f_alpha1!=NULL)&&(N2>0)&&(alpha2!=NULL)&&(f_alpha2!=NULL)&&(alpha!=NULL)&&(f_alpha!=NULL)&&(N!=NULL)) 
  { 
    register int k=0,l=0; 
    int (*compar)()=p_compare,aflg=1; 
    double alpha_max=(*(alpha1+N1-1)<*(alpha2+N2-1)?*(alpha1+N1-1):*(alpha2+N2-1)),f_alpha_a=0.; 
    point *sf_alpha=NULL; 
    if((sf_alpha=(point*)malloc((unsigned)((N1+N2)*sizeof(point))))==NULL)
    {
      fprintf(stderr,"malloc error\n"); 
      return 0;   
    }
    while((k<N1)&&(aflg))
    {
      while((*(alpha2+l)<=*(alpha1+k))&&(k<N2))
      {
	if(*(f_alpha2+l)>=*(f_alpha1+k))
	{
	  f_alpha_a=*(f_alpha1+l);
	  aflg=0;
	}
	l++;
      }
      k++;
    }
    for(k=0;k<N1;k++)  
    { 
      (*(sf_alpha+k)).x=*(alpha1+k); 
      (*(sf_alpha+k)).y=*(f_alpha1+k); 
    }   
    for(k=0;k<N2;k++)  
    { 
      (*(sf_alpha+k+N1)).x=*(alpha2+k); 
      (*(sf_alpha+k+N1)).y=*(f_alpha2+k); 
    }  
    qsort(sf_alpha,N1+N2,sizeof(point),compar);
    *alpha=(*sf_alpha).x;
    *f_alpha=(*sf_alpha).y;
    l=1;
    for(k=1;(((*(sf_alpha+k)).x<=alpha_max)&&(k<N1+N2));k++) 
    { 
      if((*(sf_alpha+k)).y>*(f_alpha+l-1))
      {
	*(alpha+l)=(*(sf_alpha+k)).x;
	*(f_alpha+l)=(*(sf_alpha+k)).y;
      l++;
      }
    }   
    *N=l;
    free((char*)sf_alpha); 
    return 1; 
    } 
  else 
  { 
    fprintf(stderr,"MFAS_sums arguments error\n"); 
    return 0; 
  } 
}

int MFAS_lump2s(int N1,double *alpha1,double *f_alpha1,int N2,double *alpha2,double *f_alpha2,double *alpha,double *f_alpha,int *N)
{
  if((N1>0)&&(alpha1!=NULL)&&(f_alpha1!=NULL)&&(N2>0)&&(alpha2!=NULL)&&(f_alpha2!=NULL)&&(alpha!=NULL)&&(f_alpha!=NULL)&&(N!=NULL))
  {
    return 1;
  }
  else
  {
    fprintf(stderr,"MFAS_lump2s arguments error\n");
    return 0;
  }
}
