#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#define sign(z) ( z< 0 ? (-1.0) : (1.0))

#define abs(z) (z >= 0 ? (z) : (-(z)))

/*******************************************************************/
/*******************************************************************/

int           n,  p, k;
double        alpha;
double        *rho, *rhoo;


/********************** calcul de la moyenne empirique **********************/


double      E(tab,n )
double      *tab ;
int           n;
{
	int        i;
	double     som = 0.0;

	for (i=0; i<n; i++){

		som += tab[i];
	}
	return(som / n);	      
}
/****************************************************************************/
/**************************ordonner les donnes******************************/

void        piksrt(n,arr)
int         n;
double      arr[];
{
	int       i, j;
	double    a;

	for (j = 1; j < n; j++) {
		a=arr[j];
		i=j-1;
		while (i >= 0 && arr[i] > a ){
			arr[i+1]=arr[i];
			i--;
		}
		arr[i+1]=a;
	}
}

/**********************calcul des coordonns polaires*************************/

double        modu(X,Y,i)
double        *X, *Y;
int            i;
{
        return((double) sqrt(pow(X[i],  2.0)+pow(Y[i],  2.0)));
}

                         /******************/

double        arg(X,Y,i)
double        *X, *Y;
int           i;

{
	if (Y[i] >= 0)
 
		return((double) acos(X[i]/rho[i]));
	else
		return((double) (2.0 * M_PI) - acos(X[i]/rho[i]));

}


/****************************************************************************/
/**********estimation empirique de la mesure spectrale normalise************/

double     mspect(X,Y, t)
double     *X,*Y;
double     t;

{
	int        i;
	double     som=0.0;
	
	for (i = 0; i < n; i++){	 
		if ((arg(X,Y,i) <= t)
		    && (rho[i] >= rhoo[n-k+1]))
		   
		som +=1.0 ;
		
	}
	
	return ((double) som / k);
}

/****************************************************************************/
/*estimation empirique de la fonction de distribution de la mesure spectrale*/ 

double     dspect(X,Y,t)
double     *X,*Y;
double     t;

{
	int        i;
	
	double som = 0.0;

	for (i=0;i<n;i++){
		
		if ((arg(X,Y,i) <= t)
		   && (rho[i] >= rhoo[n-k+1]))
		   
		som +=1.0 ;
	}

	return ((double) (som * pow(rhoo[n-k],alpha))/n);
}
/*****************************************************************************/
/********************estimation de parametre d'echelle************************/

double scale1(X,Y)
double     *X,*Y;
{
	int        l;
	double     som=0.0;
	double     k;
	for (l=0;l<=p;l++){

		k = 2.0*l*M_PI/(p+1);
		som+= pow(abs(cos(k)), (alpha))
			*(dspect(X,Y,2.0*(l+1)*M_PI/(p+1))
			  - dspect(X,Y,2.0*l*M_PI/(p+1)));
			
}
	return((double) som);	      
}

/*****************************************************************************/

double scale2(X,Y)
double     *X,*Y;
{
	int        l;
	double     som=0.0;
	double     k;
	for (l=0;l<=p;l++){

		k = 2.0*l*M_PI/(p+1);
		som+= pow(abs(sin(k)), alpha)
			*(dspect(X,Y,2.0*(l+1)*M_PI/(p+1))
			  - dspect(X,Y,2.0*l*M_PI/(p+1)));
			
}
	return((double) som);	      
}
/*****************************************************************************/
/********************estimation de la covariation*****************************/


double cov(X,Y)
double     *X,*Y;
{
	int        l;
	double     som=0.0;
	double     k;
	for (l=0;l<=p;l++){

		k = 2.0*l*M_PI/(p+1);
		som+= (cos(k))*pow(abs(sin(k)),(alpha-1.0))*sign(sin(k))
			*(dspect(X,Y,2.0*(l+1)*M_PI/(p+1))
			  - dspect(X,Y,2.0*l*M_PI/(p+1)));
			
}
	return((double) som);	      
}
/**********************************************************************/
/**********************************************************************/

FILE           *in_f_parameters, *in_f_x , *in_f_y, *out_f,*out_spect_mes;

static char     Ucmd[] = "";
static char     Udetail[] = "\n";

main (argc, argv)


int             argc;
char            **argv;
	
{
	int            i,  j, d, l, p1, p2, p4, p5;
	double          p3, COV, CORR, S1, S2;
	double          PA_STAT, PA_SIGMA, T_PA_STATISTIC;
	double          NA_STAT, NA_SIGMA, T_NA_STATISTIC;
	double         *x, *y, *X, *Y, *x1, *y1, *phi,*TMP;

	char            order[80];

	if ((in_f_parameters = fopen (argv[1], "r")) == NULL) {
                fprintf (stderr, "The file  %s does not exist\n", argv[1]);
                exit (1);
	}

	if ((in_f_x = fopen (argv[2], "r")) == NULL) {
                fprintf (stderr, "The file  %s does not exist\n", argv[2]);
                exit (1);
	}

	/*if ((in_f_y = fopen (argv[3], "r")) == NULL) {
                fprintf (stderr, "The file  %s does not exist\n", argv[3]);
                exit (1);
	}*/
	
	if ((out_f = fopen (argv[3], "w")) == NULL) {
                fprintf (stderr, "I can not write in  %s \n", argv[3]);
                exit (1);
	}

	if ((out_spect_mes = fopen (argv[4], "w")) == NULL) {
                fprintf (stderr, "I can not write in  %s \n", argv[4]);
                exit (1);
	}
	
	fscanf (in_f_parameters, "%d %d  %lf %d %d" , &p1, &p2, &p3, &p4, &p5);
	n = p1;
	d = p2;
	alpha=p3;
	k=p4;
	p=p5;

	fclose (in_f_parameters );

	
/*************************Allocation de memoire*****************************/	

	x = (double *) malloc (sizeof (double) * n);
	y = (double *) malloc (sizeof (double) * n);	

	x1 = (double *) malloc (sizeof (double) * n);
	y1 = (double *) malloc (sizeof (double) * n);
	
	X = (double *) malloc (sizeof (double) * n);
	Y = (double *) malloc (sizeof (double) * n);
	
	rho = (double *) malloc (sizeof (double) * n);
	rhoo = (double *) malloc (sizeof (double) * n);
	TMP = (double *) malloc (sizeof (double) * n);
	
	phi = (double *) malloc (sizeof (double) * (p+1));
	
/***************************************************************************/	
	for(i=0;i<n;i++) {
		fscanf (in_f_x, "%lf %lf\n" , &x1[i],&y1[i]);
		x[i] = x1[i];
		y[i] = y1[i];
		}
	fclose (in_f_x );

	/*for(i=0;i<n;i++) {
		fscanf (in_f_y, "%lf\n" , &y1[i]);
		y[i] = y1[i];
		}
	fclose (in_f_y);*/

/************************On centre les variables****************************/	
	for(i=0;i<n;i++) {
		X[i] = x[i]-E(x,n);
		Y[i] = y[i]-E(y,n);
	}

/*************************On calcule le vecteur du module*******************/
	for(i=0;i<n;i++) {
		rho[i] = modu(x,y,i);			
	} 

	for(i=0;i<n;i++) {
		TMP[i]=rho[i];			
	}   	
	piksrt(n,TMP);
	
	for(i=0;i<n;i++) {
		rhoo[i]=TMP[i];
	}
/***************************************************************************/

	for (l=0;l<=p;l++){
               phi[l]= mspect(x,y,2.0*l*M_PI/(p+1));
               fprintf (out_spect_mes, "%lf\t %lf\n", 2.0*l*M_PI/(p+1),phi[l]);
        }
/***************************************************************************/

	PA_STAT  = mspect(x,y,M_PI)-mspect(x,y,M_PI/2.0)
		   -mspect(x,y,3.0*M_PI/2.0)+1;

	PA_SIGMA  = sqrt(mspect(x,y,3.0*M_PI/2.0) 
		     - pow(mspect(x,y,3.0*M_PI/2.0),2.0)
		     - mspect(x,y,M_PI) - pow(mspect(x,y,M_PI),2.0)
		     + mspect(x,y,M_PI/2.0) - pow(mspect(x,y,M_PI/2.0),2.0)
		     + 2 * mspect(x,y,3.0*M_PI/2.0) * mspect(x,y,M_PI)
		     - 2 * mspect(x,y,3.0*M_PI/2.0) * mspect(x,y,M_PI/2.0)
		     + 2 * mspect(x,y,M_PI) * mspect(x,y,M_PI/2.0) + 1);

	T_PA_STATISTIC = sqrt(k)*(PA_STAT)/PA_SIGMA ;

/****************************************************************************

	NA_STAT  = mspect(x,y,M_PI/2.0)+mspect(x,y,3.0*M_PI/2.0)
		   -mspect(x,y,M_PI);

	NA_SIGMA  = sqrt(mspect(x,y,M_PI/2.0) - pow(mspect(x,y,M_PI/2.0),2.0)
		     + mspect(x,y,3.0*M_PI/2.0) 
		     - pow(mspect(x,y,3.0*M_PI/2.0),2.0)
		     - mspect(x,y,M_PI) - pow(mspect(x,y,M_PI),2.0)
		     + 2 * mspect(x,y,3.0*M_PI/2.0) * mspect(x,y,M_PI/2.0)
		     - 2 * mspect(x,y,M_PI) * mspect(x,y,M_PI/2.0) 
		     - 2 * mspect(x,y,3.0*M_PI/2.0) * mspect(x,y,M_PI));
	
	T_NA_STATISTIC = sqrt(k)*(NA_STAT)/NA_SIGMA ;
	
****************************************************************************/
	
	COV = cov(x,y);
	
	S1 = scale1(x,y);
	S2 = scale2(x,y);

	CORR = cov(x,y) / (pow(S1,1.0/alpha) 
		         * pow(S2,(alpha - 1.0)/alpha));      

/****************************************************************************/
/*******reprsentation graphique de la fonction de rpartition spectrale*****/ 

        sprintf (order, "xgraph  spect_mes& ");
        system (order);
	fclose (out_spect_mes);

/***************************************************************************/


fprintf(out_f,"------------------------------------------------------- " "\n");
fprintf(out_f,"               Definition of parameters                    \n");
fprintf(out_f,"------------------------------------------------------- " "\n");

		fprintf(out_f,  "  \n");
		fprintf(out_f,  "  Number of observations =  %d\n",n);
		fprintf(out_f,  "  Number of variables = %d\n",d);
		fprintf(out_f,  "  alpha =  %lf\n",alpha);
		fprintf(out_f,  "  k =  %d\n",k);
		fprintf(out_f,  "  p =  %d\n\n",p);	
	        fprintf(out_f,  "  \n\n");
	
fprintf(out_f,"--------------------------------------------------------" "\n");
fprintf(out_f,"               Test for positive Association               \n");
fprintf(out_f,"--------------------------------------------------------" "\n");

 fprintf(out_f,  "  \n");
 fprintf(out_f, " phi(pi)-phi(pi/2)-phi(3 pi/2)+1 =  %lf\n\n",PA_STAT);
 fprintf(out_f, " Standad-Deviation: PA-SIGMA  =  %lf\n\n",PA_SIGMA);
 fprintf(out_f, " Statistic for Test: T-PA-STATISTIC =  %lf\n",T_PA_STATISTIC);
 fprintf(out_f, "  \n\n");

/*       
fprintf(out_f,"--------------------------------------------------------" "\n");
fprintf(out_f,"               Test for negative Association               \n");
fprintf(out_f,"--------------------------------------------------------" "\n");

 fprintf(out_f,  "  \n");
 fprintf(out_f, " phi(pi/2)+phi(3 pi/2)-phi(pi) =  %lf\n",NA_STAT);
 fprintf(out_f, " Standad-Deviation: PA-SIGMA  =  %lf\n",NA_SIGMA);
 fprintf(out_f, " Statistic for Test: T-PA-STATISTIC =  %lf\n",T_NA_STATISTIC);
 fprintf(out_f, "  \n\n");
*/

fprintf(out_f,"--------------------------------------------------------" "\n");
fprintf(out_f,"                         Scale                             \n");
fprintf(out_f,"--------------------------------------------------------" "\n");
fprintf(out_f,  "  \n");
fprintf(out_f,"Scale of x: Gamma(x)=%lf\n",pow(S1,(1.0/alpha)));
fprintf(out_f,"Scale of y: Gamma(y)=%lf\n",pow(S2,(1.0/alpha)));
fprintf(out_f, "  \n\n");

fprintf(out_f,"--------------------------------------------------------" "\n");
fprintf(out_f,"                         Scale^alpha                       \n");
fprintf(out_f,"--------------------------------------------------------" "\n");
fprintf(out_f,  "  \n");
fprintf(out_f,"Scale of x^alpha: Gamma(x)=%lf\n",S1);
fprintf(out_f,"Scale of y^alpha: Gamma(y)=%lf\n",S2);
fprintf(out_f, "  \n\n");

fprintf(out_f,"--------------------------------------------------------" "\n");
fprintf(out_f,"                         Covariation                       \n");
fprintf(out_f,"--------------------------------------------------------" "\n");
 fprintf(out_f,  "  \n");
 fprintf(out_f,  " Covariation of x on y: COVA(x , y) = %lf\n",COV);
 fprintf(out_f, "  \n\n");

fprintf(out_f,"--------------------------------------------------------" "\n");
fprintf(out_f,"                         Correlation                       \n");
fprintf(out_f,"--------------------------------------------------------" "\n");
 fprintf(out_f,  "  \n");
 fprintf(out_f,  " Corelation of x and y: CORR(x , y) = %lf\n",CORR);
fprintf(out_f, "  \n");

fprintf(out_f,"--------------------------------------------------------" "\n");
fprintf(out_f,"                             Beta                          \n");
fprintf(out_f,"--------------------------------------------------------" "\n");
 fprintf(out_f,  "  \n");
 fprintf(out_f,  " beta of x : Beta(x ) = %lf\n",COV/scale2(x,y));
fprintf(out_f, "  \n");

fprintf(out_f, "-------------------------------------------------------" "\n");

/***************************************************************************/
  
      fclose (out_f);
}





