#include "sim_stable.h"
#include <stdio.h>
#include <math.h>
#include "FRACLAB_compat.h"
#ifndef M_PI
#define M_PI 3.1415926535
#endif
#ifndef M_PI_2
#define M_PI_2 9.86960440052517
#endif

/***************************************************************************/
/*simulation d'une loi uniforme sur [-pi/2 , pi/2]*/
/***************************************************************************/
double stable_uniform()
{
	double u,v;	
	u=drand48();	
	return(M_PI * (u - 0.5));
}
/***************************************************************************/
/*simulation d'une loi exponentielle*/
/***************************************************************************/
double stable_expo()
{
	double u;
        u=drand48();
	return(-log (1.0-u));
}
/***************************************************************************/
double stable_s(double alpha, double beta, int n)
{
        
	double          V, W, C, D,Y,ka,b,V0,Z;
	
	ka=1.0-fabs(1.0 - alpha);
	V0=(-(M_PI_2*beta*ka/alpha));

	V=stable_uniform();V=stable_uniform();
	W=stable_expo();W=stable_expo();

	Z= (sin(alpha*(V))/pow(cos(V),(1.0/alpha)))
	  *pow(cos(V-alpha*(V))/W,((1.0-alpha)/alpha));

	Y=sin(alpha*(V-V0))/pow(cos(V),(1.0/alpha))
	  *pow(cos(V-alpha*(V-V0))/W,((1.0-alpha)/alpha));
	
	if (alpha == 2.0)
	  return(2.0*sqrt(W)*sin(V));

	if(alpha == 1.0)
	  return((2.0/M_PI)*((M_PI_2+beta*V))*tan(V)
			      -beta*log(M_PI_2*W*cos(V)/(M_PI_2+(beta*V))));
	return ((beta==0.0 ? (Z) : Y));
}

/***************************************************************************/






