#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "stable_sm.h"
#ifndef sign
#define sign(z) (z<0 ? (-1.0) : (1.0))
#endif
/****************************************************************************/

void stable_root(double *tab, int size, double v, double *mindiff, int *posmin)
{
  int i;
  *posmin = 0;
  *mindiff = fabs(*tab-v);
  for(i=0;i<size;i++){
    if(fabs(tab[i]-v)< *mindiff){
      *mindiff = fabs(tab[i]-v);
      *posmin = i;
    }
  }
} 
/****************************************************************************/

double     stable_alpha(double *tab, int k, int size)
 
{
        return((double) log(2.0)/(log(tab[size-k+1])
                        - log(tab[size-2*k+1])) );

}

/*************************************************************************/
/**********************calcul des coordonns polaires*************************/

double        stable_modu(double *X,double *Y,int i)
{
        return((double) sqrt(pow(X[i],  2.0)+pow(Y[i],  2.0)));
}

                         /******************/

double        stable_arg(double *X,double *Y,int i)

{
  if (Y[i] >= 0)
    return((double) acos(X[i]/stable_modu(X,Y,i)));
  else
    return((double) (2.0*M_PI)-acos(X[i]/stable_modu(X,Y,i)));

}
/*************************************************************************/
double  stable_mspect(double *X,double *Y, int size, double t, double *Z,int k)

{
	int        i;
	double     som=0.0;
	
	for (i = 0; i < size; i++){	 
		if ((stable_arg(X,Y,i) <= t)
		    && (stable_modu(X,Y,i) >= Z[size-k+1]))
		   
		som +=1.0 ;
		
	}
	
	return ((double) som / k);
}
/*************************************************************************/





