/* This Software is ( Copyright INRIA . 1998 1999 1 )                */
/*                                                                   */
/* INRIA  holds all the ownership rights on the Software.            */
/* The scientific community is asked to use the SOFTWARE             */
/* in order to test and evaluate it.                                 */
/*                                                                   */
/* INRIA freely grants the right to use modify the Software,         */
/* integrate it in another Software.                                 */
/* Any use or reproduction of this Software to obtain profit or      */
/* for commercial ends being subject to obtaining the prior express  */
/* authorization of INRIA.                                           */
/*                                                                   */
/* INRIA authorizes any reproduction of this Software.               */
/*                                                                   */
/*    - in limits defined in clauses 9 and 10 of the Berne           */
/*    agreement for the protection of literary and artistic works    */
/*    respectively specify in their paragraphs 2 and 3 authorizing   */
/*    only the reproduction and quoting of works on the condition    */
/*    that :                                                         */
/*                                                                   */
/*    - "this reproduction does not adversely affect the normal      */
/*    exploitation of the work or cause any unjustified prejudice    */
/*    to the legitimate interests of the author".                    */
/*                                                                   */
/*    - that the quotations given by way of illustration and/or      */
/*    tuition conform to the proper uses and that it mentions        */
/*    the source and name of the author if this name features        */
/*    in the source",                                                */
/*                                                                   */
/*    - under the condition that this file is included with          */
/*    any reproduction.                                              */
/*                                                                   */
/* Any commercial use made without obtaining the prior express       */
/* agreement of INRIA would therefore constitute a fraudulent        */
/* imitation.                                                        */
/*                                                                   */
/* The Software beeing currently developed, INRIA is assuming no     */
/* liability, and should not be responsible, in any manner or any    */
/* case, for any direct or indirect dammages sustained by the user.  */
/*                                                                   */
/* Any user of the software shall notify at INRIA any comments       */
/* concerning the use of the Sofware (e-mail : FracLab@inria.fr)     */
/*                                                                   */
/* This file is part of FracLab, a Fractal Analysis Software         */

/* This Software is ( Copyright INRIA . 1998 1999 1 )                */
/*                                                                   */
/* INRIA  holds all the ownership rights on the Software.            */
/* The scientific community is asked to use the SOFTWARE             */
/* in order to test and evaluate it.                                 */
/*                                                                   */
/* INRIA freely grants the right to use modify the Software,         */
/* integrate it in another Software.                                 */
/* Any use or reproduction of this Software to obtain profit or      */
/* for commercial ends being subject to obtaining the prior express  */
/* authorization of INRIA.                                           */
/*                                                                   */
/* INRIA authorizes any reproduction of this Software.               */
/*                                                                   */
/*    - in limits defined in clauses 9 and 10 of the Berne           */
/*    agreement for the protection of literary and artistic works    */
/*    respectively specify in their paragraphs 2 and 3 authorizing   */
/*    only the reproduction and quoting of works on the condition    */
/*    that :                                                         */
/*                                                                   */
/*    - "this reproduction does not adversely affect the normal      */
/*    exploitation of the work or cause any unjustified prejudice    */
/*    to the legitimate interests of the author".                    */
/*                                                                   */
/*    - that the quotations given by way of illustration and/or      */
/*    tuition conform to the proper uses and that it mentions        */
/*    the source and name of the author if this name features        */
/*    in the source",                                                */
/*                                                                   */
/*    - under the condition that this file is included with          */
/*    any reproduction.                                              */
/*                                                                   */
/* Any commercial use made without obtaining the prior express       */
/* agreement of INRIA would therefore constitute a fraudulent        */
/* imitation.                                                        */
/*                                                                   */
/* The Software beeing currently developed, INRIA is assuming no     */
/* liability, and should not be responsible, in any manner or any    */
/* case, for any direct or indirect dammages sustained by the user.  */
/*                                                                   */
/* Any user of the software shall notify at INRIA any comments       */
/* concerning the use of the Sofware (e-mail : FracLab@inria.fr)     */
/*                                                                   */
/* This file is part of FracLab, a Fractal Analysis Software         */

#include <math.h>
#include<string.h>

#ifndef MIN
#define MIN(A,B) ((A) < (B) ? (A) : (B))
#endif

#ifndef MAX
#define MAX(A,B) ((A) > (B) ? (A) : (B))
#endif




/*=======================================================

	Assumptions:	1)  WinWidth and SubWinWidth are odd
				2)  Signal is normalized
				3)
========================================================*/

void getDecOscCon(  const double Signal[],  
		    long sizeData,
		    double *SignalOsc,
			double *CondOsc, 
			int sizeCO,
			int WinWidth, 
			int SubWinWidth, 
			double binWidth  ) {

        double  datum,
        	winMax=0.0,
                winMin=1.0,
        	subwinMax=0.0,
                subwinMin=1.0;                
        long    endValue,
                lastWinVal,
                firstsubval,
                lastsubval;
        long    i,j,k,l;
	int	hop = floor( (WinWidth-1)/(SubWinWidth-1) ),winOsc,subwinOsc;
	long    cursor;
	
        endValue=sizeData-WinWidth+1;
           
	/* NECESSARY ?        
	memset(CondOsc, 0, sizeCO*sizeCO*sizeof(double) );
	memset(CondOsc2, 0, sizeCO*sizeCO*sizeof(double) );
	*/
        
        /* LOOP THROUGH THE DATA SET */
        for(i = 0; i < endValue; i++) {
            /* INIT TO GET STATS FOR POINT i+((WINWIDTH-1)/2) */
            subwinMax=0.0; subwinMin=1.0; 
            winMax=0.0;    winMin=1.0;
	    lastWinVal  = i+WinWidth;
	    firstsubval = i+1;   
            lastsubval  = i+hop;

	    /* GET i^th SUBSAMPWINDOW STATS */	    
            for(j = i; j < lastWinVal; j += hop) {   
		    datum=Signal[j];		    
                    subwinMax=MAX(subwinMax,datum);
                    subwinMin=MIN(subwinMin,datum);
            }
            
            /* GET i^th FULL WINDOW STATS BY LOOKING AT REMAINING */
            /*    ELEMENTS IN WINDOW */             
            for(k = firstsubval; k < lastsubval; k++) {
               for(l = k; l < lastWinVal; l += hop) {
               		    datum=Signal[l];		    
                        winMax=MAX(winMax,datum);
                        winMin=MIN(winMin,datum);
               }
            }
            /* GET MAX and MIN OVERALL */
            winMax=MAX(winMax,subwinMax);
            winMin=MIN(winMin,subwinMin);
            /* AND REPORT THE SIGNAL OSC */
            SignalOsc[i]=winMax-winMin;
            winOsc =   (int)(SignalOsc[i]/binWidth) ;            
            subwinOsc = (int)((subwinMax-subwinMin)/binWidth);
            CondOsc[winOsc + subwinOsc * sizeCO]++;
            
        }
        return;
}



